Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionEight.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionEight.cs	(revision 7427)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionEight.cs	(revision 7428)
@@ -38,6 +38,6 @@
       targetVariable = "F";
       inputVariables = new List<string>() { "X" };
-      trainingPartition = new IntRange(0, 101);
-      testPartition = new IntRange(101, 1103);
+      trainingPartition = new IntRange(0, 100);
+      testPartition = new IntRange(100, 1091);
     }
 
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionFifteen.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionFifteen.cs	(revision 7427)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionFifteen.cs	(revision 7428)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(2500, 2600);
+      testPartition = new IntRange(2500, 5000);
     }
 
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionSixteen.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionSixteen.cs	(revision 7427)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionSixteen.cs	(revision 7428)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(2500, 2600);
+      testPartition = new IntRange(2500, 5000);
     }
 
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionThirteen.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionThirteen.cs	(revision 7427)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionThirteen.cs	(revision 7428)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(2500, 2600);
+      testPartition = new IntRange(2500, 5000);
     }
 
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionTwelve.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionTwelve.cs	(revision 7427)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionTwelve.cs	(revision 7428)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(2500, 2600);
+      testPartition = new IntRange(2500, 5000);
     }
 
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Other/SpatialCoevolution.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Other/SpatialCoevolution.cs	(revision 7427)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Other/SpatialCoevolution.cs	(revision 7428)
@@ -40,6 +40,6 @@
       targetVariable = "F";
       inputVariables = new List<string>() { "X", "Y" };
-      trainingPartition = new IntRange(0, 676);
-      testPartition = new IntRange(676, 976);
+      trainingPartition = new IntRange(0, 1000);
+      testPartition = new IntRange(1000, 1676);
     }
 
@@ -65,6 +65,6 @@
 
       for (int i = 0; i < inputVariables.Count; i++) {
-        dataList.Add(testData[i]);
-        dataList[i].AddRange(RegressionBenchmark.GenerateUniformDistributedValues(1000, range));
+        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, range));
+        dataList[i].AddRange(testData[i]);
       }
 